package fr.plnech.dunbar

import android.os.Bundle
import android.provider.ContactsContract
import android.view.Menu
import android.view.MenuItem
import android.widget.ArrayAdapter
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import com.google.android.material.snackbar.Snackbar
import kotlinx.android.synthetic.main.activity_main.*
import kotlinx.android.synthetic.main.content_main.*


class MainActivity : AppCompatActivity() {

    private val CONTENT_VIEW_ID = 10101010

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        setSupportActionBar(toolbar)




        fab.setOnClickListener { view ->
            Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                .setAction("Action", null).show()
        }

        fetchFriends()
    }

    override fun onCreateOptionsMenu(menu: Menu): Boolean {
        // Inflate the menu; this adds items to the action bar if it is present.
        menuInflater.inflate(R.menu.menu_main, menu)
        return true
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        return when (item.itemId) {
            R.id.action_settings -> true
            else -> super.onOptionsItemSelected(item)
        }
    }

    fun fetchFriends() {
        contentResolver.query(
            ContactsContract.CommonDataKinds.Phone.CONTENT_URI,
            null,
            null,
            null,
            null
        )?.let {

            val contacts = mutableListOf<List<Pair<String, String>>>()
            while (it.moveToNext()) {
                contacts.add(mutableListOf<Pair<String, String>>().also { contact ->
                    it.columnNames.forEach { name ->
                        contact.add(Pair(name, it.getString(it.getColumnIndex(name))))
                    }
                })
            }

            friends.adapter =
                ArrayAdapter<String>(this, R.layout.contact, R.id.name,
                    contacts.map { contact ->
                        contact.filter { !it.second.isNullOrBlank() }
                            .joinToString { "${it.first}:${it.second}" }
                    })

            val nbFriends = friends.adapter.count
            welcomeTitle.text = "$nbFriends ${"friend".plural(nbFriends)} on Dunbar"

            Toast.makeText(this@MainActivity, "$nbFriends ", Toast.LENGTH_LONG).show()

            it?.close()
        }


    }
}
